#include "error.h"

#include <stdio.h>
#include <stdlib.h>

void hsm_error(error_kind kind) {
  if (kind == ERROR_NO_ERROR) {
    return;
  }

  fprintf(stderr, "HSM Error: ");
  switch (kind) {
  case ERROR_AUTH:
    fprintf(stderr, "Auth failed.\n");
    break;
  case ERROR_INPUT:
    fprintf(stderr, "Bad input.\n");
    break;
  case ERROR_INTERNAL:
    fprintf(stderr, "Internal error.\n");
    break;
  case ERROR_OPENSSL:
    fprintf(stderr, "OpenSSL error.\n");
    break;
  default:
    fprintf(stderr, "Unknown error.\n");
    break;
  }
  fflush(stderr);

  exit(EXIT_FAILURE);
}
